#ifndef	_RC433_H
#define	_RC433_H

#define TRUE 1
#define FALSE 0

#include "../config.h"

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <sys/types.h>
#include <stdbool.h>


/* wiringPi */
#include <wiringPi.h>


/* rc-switch.c */
int  toggleSwitch(char *);
int  toggleTypeA(char *, char *, bool);
int  toggleTypeB(int, int, bool);
int  toggleTypeC(char, int, int, bool);
int  toggleTypeE(char, int, bool);

void enableReceiveIRQ(int interrupt);
void enableReceive(void);
void disableReceive(void);
bool available(void);
void resetAvailable(void);

unsigned long getReceivedValue(void);
unsigned int getReceivedBitlength(void);
unsigned int getReceivedDelay(void);
unsigned int getReceivedProtocol(void);
unsigned int *getReceivedRawdata(void);

void enableTransmit(int);
void disableTransmit(void);

char *dec2binWzerofill(unsigned long, unsigned int);


/* xutil.c */
char *xmalloc(size_t);
char *xstrcpy(char *);
char *xstrcat(char *, char *);


#endif
